var reliby = {

	_console: false,

	init: function() {
	},

	reloadLiveBookmarks: function() {
		var rdf = Components.classes["@mozilla.org/rdf/rdf-service;1"].getService(Components.interfaces.nsIRDFService);
		var bmds;
		try {
			bmds = rdf.GetDataSource("rdf:bookmarks");
		} catch(ex) {
			this.trace("Unable to get bookmarks datasource");
		}
		if (!bmds)
			return;
		var nameArc = rdf.GetResource("http://home.netscape.com/NC-rdf#Name");
		var feedArc = rdf.GetResource("http://home.netscape.com/NC-rdf#FeedURL");
		var feedExp = rdf.GetResource("http://home.netscape.com/NC-rdf#LivemarkExpiration");
		var iter = bmds.GetAllResources();
		var num_to = 0;
		var num_ok = 0;
		while (iter.hasMoreElements()) {
			try {
				var element = iter.getNext();
				element.QueryInterface(Components.interfaces.nsIRDFResource);
				var target = bmds.GetTarget(element, nameArc, true);
				if (target == null)
					continue;
				var name = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
				target = bmds.GetTarget(element, feedArc, true);
				if (target == null)
					continue;
				var url = target.QueryInterface(Components.interfaces.nsIRDFLiteral).Value;
				var rsrc = rdf.GetResource(element.Value);
				target = bmds.GetTarget(rsrc, feedExp, true);
				num_to++;
				if (target) {
					bmds.Unassert(rsrc, feedExp, target);
					this.trace("Reloading " + url);
					num_ok++;
				} else {
					this.trace("Live bookmark is not loaded yet or unable to reload: " + url);
				}
			} catch(ex) {
				this.trace("Error: " + ex);
			}
		}
		if (num_to)
			this.updateStatusbar(num_ok + " out of " + num_to + " Live Bookmarks reloaded");
	},

	updateStatusbar: function(txt) {
		this.trace(txt);
		var stat = document.getElementById("statusbar-display");
		if (stat)
			stat.label = "reliby: " + txt;
	},

	trace: function(msg) {
		if (!this._console) {
			this._console = Components.classes["@mozilla.org/consoleservice;1"].getService(Components.interfaces.nsIConsoleService);
		}
		this._console.logStringMessage("reliby: " + msg);
	}

};

window.addEventListener("load", function(e) {reliby.init(e)}, false);
